Class('App.Com.AccountList', 'xui.Com',{
    Instance:{
        iniComponents:function(){
            // [[Code created by CrossUI RAD Studio
            var host=this, children=[], append=function(child){children.push(child.get(0));};
            
            append(
                (new xui.UI.Block())
                .setHost(host,"paneMain")
                .setDock("fill")
                .setBorderType("none")
            );
            
            host.paneMain.append(
                (new xui.UI.Layout())
                .setHost(host,"layout")
                .setItems([{
                    "id" : "before",
                    "pos" : "before",
                    "min" : 100,
                    "size" : 200,
                    "locked" : false,
                    "folded" : false,
                    "hidden" : true,
                    "cmd" : false,
                    "itemDisplay" : "display:none;"
                },{
                    "id" : "main",
                    "min" : 100
                }])
                .setType("horizontal")
                );
            
            host.layout.append(
                (new xui.UI.Pane())
                .setHost(host,"paneContent")
                .setDock("fill")
                , "main");
            
            host.paneContent.append(
                (new xui.UI.ToolBar())
                .setHost(host,"toolbar")
                .setItems([{
                    "id" : "grp1",
                    "sub" : [{
                        "id" : "new",
                        "caption" : "",
                        "image" : "{/}img/icons.png",
                        "imagePos" : "-32px top"
                    },{
                        "id" : "edit",
                        "caption" : "",
                        "image" : "{/}img/icons.png",
                        "imagePos" : "-96px top"
                    },{
                        "id" : "delete",
                        "caption" : "",
                        "image" : "{/}img/icons.png",
                        "imagePos" : "-128px top"
                    }],
                    "caption" : "grp1"
                }])
                .setHandler(false)
                .onClick([{
                    "desc" : "delete-check",
                    "type" : "other",
                    "target" : "msg",
                    "params" : ["No seleted","You shoud select one or more rows first!"],
                    "method" : "pop",
                    "conditions" : [{
                        "left" : "{args[1].id}",
                        "symbol" : "=",
                        "right" : "delete"
                    },{
                        "left" : "{page.grid.getValue()}",
                        "symbol" : "empty",
                        "right" : ""
                    }],
                    "return" : false
                },{
                    "desc" : "delete-confirm",
                    "type" : "other",
                    "target" : "msg",
                    "params" : ["Confirm","Do you want to delete?"],
                    "method" : "confirm",
                    "conditions" : [{
                        "left" : "{args[1].id}",
                        "symbol" : "=",
                        "right" : "delete"
                    }],
                    "onOK" : 2,
                    "onKO" : 3
                },{
                    "desc" : "delete-exec",
                    "type" : "control",
                    "target" : "grid",
                    "params" : ["{page.grid.getValue()}"],
                    "method" : "removeRows",
                    "conditions" : [{
                        "left" : "{args[1].id}",
                        "symbol" : "=",
                        "right" : "delete"
                    },{
                        "left" : "{temp.okData}",
                        "symbol" : "!=",
                        "right" : "{undefined}"
                    }]
                },{
                    "desc" : "delete-message",
                    "type" : "other",
                    "target" : "msg",
                    "params" : ["deleted!","deleted",200,5000],
                    "method" : "message",
                    "conditions" : [{
                        "left" : "{args[1].id}",
                        "symbol" : "=",
                        "right" : "delete"
                    },{
                        "left" : "{temp.okData}",
                        "symbol" : "!=",
                        "right" : "{undefined}"
                    }]
                },{
                    "desc" : "for save",
                    "type" : "other",
                    "target" : "callback",
                    "params" : ["setFormDataToGrid","{page.grid.setRowMap()}"],
                    "method" : "set",
                    "conditions" : [{
                        "left" : "{args[1].id}",
                        "symbol" : "!=",
                        "right" : "delete"
                    }]
                },{
                    "desc" : "new",
                    "type" : "page",
                    "target" : "App.Form.Account",
                    "params" : [],
                    "method" : "show",
                    "conditions" : [{
                        "left" : "{args[1].id}",
                        "symbol" : "=",
                        "right" : "new"
                    }]
                },{
                    "desc" : "new-status",
                    "type" : "other",
                    "target" : "var",
                    "params" : ["acc_status","new"],
                    "method" : "global",
                    "conditions" : [{
                        "left" : "{args[1].id}",
                        "symbol" : "=",
                        "right" : "new"
                    }]
                },{
                    "desc" : "new-activecb",
                    "type" : "other",
                    "target" : "callback",
                    "params" : ["setActiveRow","{page.grid.setActiveRow()}"],
                    "method" : "set",
                    "conditions" : [{
                        "left" : "{args[1].id}",
                        "symbol" : "=",
                        "right" : "new"
                    }]
                },{
                    "desc" : "new-setcallback",
                    "type" : "other",
                    "target" : "callback",
                    "params" : ["insertRow","{page.grid.insertRows()}"],
                    "method" : "set",
                    "conditions" : [{
                        "left" : "{args[1].id}",
                        "symbol" : "=",
                        "right" : "new"
                    }]
                },{
                    "desc" : "open-check",
                    "type" : "other",
                    "target" : "msg",
                    "params" : ["No ActiveRow","You shoud active a row first!"],
                    "method" : "pop",
                    "conditions" : [{
                        "left" : "{args[1].id}",
                        "symbol" : "=",
                        "right" : "edit"
                    },{
                        "left" : "{page.grid.getActiveRow()}",
                        "symbol" : "empty",
                        "right" : ""
                    }],
                    "return" : false
                },{
                    "desc" : "open-status",
                    "type" : "other",
                    "target" : "var",
                    "params" : ["acc_status","open"],
                    "method" : "global",
                    "conditions" : [{
                        "left" : "{args[1].id}",
                        "symbol" : "=",
                        "right" : "edit"
                    }]
                },{
                    "desc" : "open-fom",
                    "type" : "page",
                    "target" : "App.Form.Account",
                    "params" : [],
                    "method" : "show",
                    "conditions" : [{
                        "left" : "{args[1].id}",
                        "symbol" : "=",
                        "right" : "edit"
                    }]
                },{
                    "desc" : "open-setdatain",
                    "type" : "other",
                    "target" : "var",
                    "params" : ["FromDataIn","{page.grid.getRowMap()}"],
                    "method" : "global",
                    "conditions" : [{
                        "left" : "{args[1].id}",
                        "symbol" : "=",
                        "right" : "edit"
                    }]
                }])
                );
            
            host.paneContent.append(
                (new xui.UI.Button())
                .setHost(host,"btnRefresh")
                .setTips("$App.Com.GridForSel.refreshlabel")
                .setTop(4)
                .setWidth(80)
                .setHeight(21)
                .setRight(10)
                .setCaption("Refresh")
                .setImage("{/}img/icons.png")
                .setImagePos("-128px -64px")
                );
            
            host.paneContent.append(
                (new xui.UI.PageBar())
                .setHost(host,"pagebar")
                .setDirtyMark(false)
                .setTop(3)
                .setRight(100)
                .setCaption("")
                .onClick("_pagebar_onClick")
                );
            
            host.paneContent.append(
                (new xui.UI.SLabel())
                .setHost(host,"l_title")
                .setLeft(230)
                .setTop(6)
                .setHeight(17)
                .setZIndex(0)
                .setCaption("")
                .setHAlign("center")
                .setCustomStyle({
                    "KEY" : "font-size:12px;font-weight:bold"
                })
                );
            
            host.paneContent.append(
                (new xui.UI.TreeGrid())
                .setHost(host,"grid")
                .setDirtyMark(false)
                .setSelMode("multibycheckbox")
                .setAltRowsBg(true)
                .setRowNumbered(true)
                .setColHidable(true)
                .setColMovable(true)
                .setHeader([{
                    "type" : "input",
                    "caption" : "Name",
                    "init" : "",
                    "required" : true,
                    "width" : 120,
                    "id" : "account_name"
                },{
                    "type" : "listbox",
                    "editorListItems" : [{
                        "id" : "noidea",
                        "caption" : "No Idea"
                    },{
                        "id" : "Association",
                        "caption" : "Association"
                    },{
                        "id" : "Government",
                        "caption" : "Government"
                    },{
                        "id" : "Commercial",
                        "caption" : "Commercial"
                    },{
                        "id" : "Distributor",
                        "caption" : "Distributor"
                    },{
                        "id" : "Other",
                        "caption" : "Others"
                    }],
                    "caption" : "Category",
                    "required" : true,
                    "init" : "noidea",
                    "width" : 80,
                    "id" : "account_type"
                },{
                    "type" : "textarea",
                    "caption" : "Address",
                    "width" : 120,
                    "relWidth" : true,
                    "id" : "account_address"
                }])
                .setRows([{
                    "id" : "fpcTsPm8PWMZ5mZJ",
                    "cells" : [{
                        "value" : "K Co.,"
                    },{
                        "value" : "Commercial"
                    },{
                        "value" : ""
                    }]
                },{
                    "id" : "ryUIeTQRMv0yTHD6",
                    "cells" : [{
                        "value" : "I Co.,"
                    },{
                        "value" : "Government"
                    },{
                        "value" : ""
                    }]
                },{
                    "id" : "PpSYc5mclKxPtJOQ",
                    "cells" : [{
                        "value" : "D Co.,"
                    },{
                        "value" : "Commercial"
                    },{
                        "value" : ""
                    }]
                },{
                    "id" : "U4eZnZuq9v4quTAo",
                    "cells" : [{
                        "value" : "C Co.,"
                    },{
                        "value" : "Commercial"
                    },{
                        "value" : ""
                    }]
                },{
                    "id" : "d364H1cDSSxDFX1q",
                    "cells" : [{
                        "value" : "B Co.,"
                    },{
                        "value" : "Government"
                    },{
                        "value" : ""
                    }]
                },{
                    "id" : "zn0AQSnigLu3qP3R",
                    "cells" : [{
                        "value" : "A Co.,"
                    },{
                        "value" : "Association"
                    },{
                        "value" : ""
                    }]
                },{
                    "id" : "c0pAwvJTww48NRnf",
                    "cells" : [{
                        "value" : "J co.,"
                    },{
                        "value" : "Commercial"
                    },{
                        "value" : ""
                    }]
                },{
                    "id" : "LD9oGyY4Mce9QfBa",
                    "showLabel" : "H Co.,",
                    "cells" : [{
                        "value" : "H Co.,"
                    },{
                        "value" : "Commercial"
                    },{
                        "value" : ""
                    }]
                },{
                    "id" : "dQ6gdMb9yQoMFoRD",
                    "cells" : [{
                        "value" : "E Co.,"
                    },{
                        "value" : "Government"
                    },{
                        "value" : ""
                    }]
                },{
                    "id" : "THojjNexvpyYD1uO",
                    "cells" : [{
                        "value" : "J Co.,"
                    },{
                        "value" : "Association"
                    },{
                        "value" : ""
                    }]
                },{
                    "id" : "uKqPoWQgYlG95qvt",
                    "cells" : [{
                        "value" : "F Co.,"
                    },{
                        "value" : "Commercial"
                    },{
                        "value" : ""
                    }]
                },{
                    "id" : "2oB6SXqd5X8GaBSg",
                    "cells" : [{
                        "value" : "G Co.,"
                    },{
                        "value" : "Commercial"
                    },{
                        "value" : ""
                    }]
                }])
                .setTreeMode(false)
                .setValue("")
                .onDblclickRow([{
                    "desc" : "set status",
                    "type" : "other",
                    "target" : "var",
                    "params" : ["acc_status","open"],
                    "method" : "global"
                },{
                    "desc" : "Open Form",
                    "type" : "page",
                    "target" : "App.Form.Account",
                    "params" : [],
                    "method" : "show"
                },{
                    "desc" : "set data in",
                    "type" : "other",
                    "target" : "var",
                    "params" : ["FromDataIn","{page.grid.getRowMap()}"],
                    "method" : "global"
                },{
                    "desc" : "set callback",
                    "type" : "other",
                    "target" : "callback",
                    "params" : ["setFormDataToGrid","{page.grid.setRowMap()}"],
                    "method" : "set"
                }])
                );
            
            return children;
            // ]]Code created by CrossUI RAD Studio
        } 
    }
});